/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoXliffUtilChange]のクラス
 */
package blanco.xliff.util.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.xliff.util.task.valueobject.BlancoXliffUtilChangeProcessInput;

/**
 * Apache Antタスク [BlancoXliffUtilChange]のクラス。
 *
 * [XLIFF対応ツール] XLIFF の変更を行います。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.xliff.util.task]にBlancoXliffUtilChangeBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancoxliffutilchange&quot; classname=&quot;blanco.xliff.util.task.BlancoXliffUtilChangeTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoXliffUtilChangeTask extends Task {
    /**
     * [XLIFF対応ツール] XLIFF の変更を行います。
     */
    protected BlancoXliffUtilChangeProcessInput fInput = new BlancoXliffUtilChangeProcessInput();

    /**
     * [XLIFF対応ツール] XLIFF の変更を行います。
     */
    protected boolean fIsFieldXliffdirProcessed = false;

    /**
     * [XLIFF対応ツール] XLIFF の変更を行います。
     */
    protected boolean fIsFieldSettargetifnotexistProcessed = false;

    /**
     * [XLIFF対応ツール] XLIFF の変更を行います。
     */
    protected boolean fIsFieldSortalttransProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFF (*.xlf) ディレクトリ<br>
     *
     * @param arg セットしたい値
     */
    public void setXliffdir(final String arg) {
        fInput.setXliffdir(arg);
        fIsFieldXliffdirProcessed = true;
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFF (*.xlf) ディレクトリ<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getXliffdir() {
        return fInput.getXliffdir();
    }

    /**
     * Antタスクの[settargetifnotexist]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * target が無い場合に target をセットするかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setSettargetifnotexist(final boolean arg) {
        fInput.setSettargetifnotexist(arg);
        fIsFieldSettargetifnotexistProcessed = true;
    }

    /**
     * Antタスクの[settargetifnotexist]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * target が無い場合に target をセットするかどうか。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getSettargetifnotexist() {
        return fInput.getSettargetifnotexist();
    }

    /**
     * Antタスクの[sortalttrans]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * alt-trans をソートするかどうか。参照実装では match-quality によるソート。<br>
     *
     * @param arg セットしたい値
     */
    public void setSortalttrans(final boolean arg) {
        fInput.setSortalttrans(arg);
        fIsFieldSortalttransProcessed = true;
    }

    /**
     * Antタスクの[sortalttrans]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * alt-trans をソートするかどうか。参照実装では match-quality によるソート。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getSortalttrans() {
        return fInput.getSortalttrans();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoXliffUtilChangeTask begin.");

        // 項目番号[1]、アトリビュート[xliffdir]は必須入力です。入力チェックを行います。
        if (fIsFieldXliffdirProcessed == false) {
            throw new BuildException("必須アトリビュート[xliffdir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- xliffdir:[" + getXliffdir() + "]");
            System.out.println("- settargetifnotexist:[" + getSettargetifnotexist() + "]");
            System.out.println("- sortalttrans:[" + getSortalttrans() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoXliffUtilChangeProcessインタフェースを実装して blanco.xliff.util.taskパッケージに BlancoXliffUtilChangeProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoXliffUtilChangeProcess proc = new BlancoXliffUtilChangeProcessImpl();
            if (proc.execute(fInput) != BlancoXliffUtilChangeBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
